package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.preguntasRespuestas.TiposPreguntas;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * TiposPreguntasDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class TiposPreguntasDaoImpl implements TiposPreguntasDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDTIPOPREGUNTA", "DESCRIPCIONCASTELLANO",
			"DESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<TiposPreguntas> rwMap = new RowMapper<TiposPreguntas>() {
		public TiposPreguntas mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposPreguntas(resultSet.getLong("IDTIPOPREGUNTA"), resultSet.getString("DESCRIPCIONCASTELLANO"),
					resultSet.getString("DESCRIPCIONEUSKERA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"));
		}
	};

	private RowMapper<TiposPreguntas> rwMapPK = new RowMapper<TiposPreguntas>() {
		public TiposPreguntas mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new TiposPreguntas(resultSet.getLong("IDTIPOPREGUNTA"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<TiposPreguntas>> rwMapJerarquia = new RowMapper<JerarquiaDto<TiposPreguntas>>() {
		public JerarquiaDto<TiposPreguntas> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			TiposPreguntas tipospreguntas = new TiposPreguntas(resultSet.getLong("IDTIPOPREGUNTA"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getString("DESCRIPCIONEUSKERA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<TiposPreguntas> jerarquia = new JerarquiaDto<TiposPreguntas>();
			jerarquia.setModel(tipospreguntas);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @return TiposPreguntas
	 */
	public TiposPreguntas add(TiposPreguntas tipospreguntas) {
		String query = "INSERT INTO TIPOS_PREGUNTAS (ID_TIPO_PREGUNTA, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?)";
		this.jdbcTemplate.update(query, tipospreguntas.getIdTipoPregunta(), tipospreguntas.getDescripcionCastellano(),
				tipospreguntas.getDescripcionEuskera(), tipospreguntas.getFechaRegistro(),
				tipospreguntas.getUsuarioRegistro());
		return tipospreguntas;
	}

	/**
	 * Updates a single row in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @return TiposPreguntas
	 */
	public TiposPreguntas update(TiposPreguntas tipospreguntas) {
		String query = "UPDATE TIPOS_PREGUNTAS SET DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_TIPO_PREGUNTA=?";
		this.jdbcTemplate.update(query, tipospreguntas.getDescripcionCastellano(),
				tipospreguntas.getDescripcionEuskera(), tipospreguntas.getFechaRegistro(),
				tipospreguntas.getUsuarioRegistro(), tipospreguntas.getIdTipoPregunta());
		return tipospreguntas;
	}

	/**
	 * Finds a single row in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @return TiposPreguntas
	 */
	@Transactional(readOnly = true)
	public TiposPreguntas find(TiposPreguntas tipospreguntas) {
		String query = "SELECT t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM TIPOS_PREGUNTAS t1  WHERE t1.ID_TIPO_PREGUNTA = ?  ";

		List<TiposPreguntas> tipospreguntasList = this.jdbcTemplate.query(query, this.rwMap,
				tipospreguntas.getIdTipoPregunta());
		return (TiposPreguntas) DataAccessUtils.uniqueResult(tipospreguntasList);
	}

	/**
	 * Removes a single row in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @return
	 */
	public void remove(TiposPreguntas tipospreguntas) {
		String query = "DELETE FROM TIPOS_PREGUNTAS WHERE ID_TIPO_PREGUNTA=?";
		this.jdbcTemplate.update(query, tipospreguntas.getIdTipoPregunta());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<TiposPreguntas> getMultiple(TiposPreguntas filterTiposPreguntas, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterTiposPreguntas, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, TiposPreguntas.class, params,
				"ID_TIPO_PREGUNTA");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TiposPreguntas>
	 */
	@Transactional(readOnly = true)
	public List<TiposPreguntas> findAll(TiposPreguntas tipospreguntas, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM TIPOS_PREGUNTAS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tipospreguntas);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, TiposPreguntasDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<TiposPreguntas>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<TiposPreguntas> findTiposPreguntaValidar() {
		String query = "SELECT  t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO "
				+ "FROM TIPOS_PREGUNTAS t1 WHERE ID_TIPO_PREGUNTA = " + Constantes.TIPO_PREGUNTA_NUMERICO
				+ "OR ID_TIPO_PREGUNTA = " + Constantes.TIPO_PREGUNTA_FECHA + " OR ID_TIPO_PREGUNTA = "
				+ Constantes.TIPO_PREGUNTA_TEXTO_LIBRE + " OR ID_TIPO_PREGUNTA = " + Constantes.TIPO_PREGUNTA_SINO;

		return this.jdbcTemplate.query(query, this.rwMap);
	}

	/**
	 * Finds rows in the TiposPreguntas table using like.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposPreguntas>
	 */
	@Transactional(readOnly = true)
	public List<TiposPreguntas> findAllLike(TiposPreguntas tipospreguntas, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM TIPOS_PREGUNTAS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tipospreguntas, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, TiposPreguntasDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<TiposPreguntas>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the TiposPreguntas table.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(TiposPreguntas tipospreguntas) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM TIPOS_PREGUNTAS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(tipospreguntas);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the TiposPreguntas table using like.
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(TiposPreguntas tipospreguntas, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM TIPOS_PREGUNTAS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tipospreguntas, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of TiposPreguntas selected for rup_table
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposPreguntas>>
	 */
	@Override
	public List<TableRowDto<TiposPreguntas>> reorderSelection(TiposPreguntas tipospreguntas,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_PREGUNTAS t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(tipospreguntas, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, TiposPreguntas.class,
				filterParamList, "ID_TIPO_PREGUNTA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<TiposPreguntas>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            TiposPreguntas
	 * @param searchParams
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposPreguntas>>
	 */
	@Override
	public List<TableRowDto<TiposPreguntas>> search(TiposPreguntas filterParams, TiposPreguntas searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_PREGUNTAS t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, TiposPreguntas.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_TIPO_PREGUNTA");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<TiposPreguntas>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filtertipospreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(TiposPreguntas filtertipospreguntas, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM TIPOS_PREGUNTAS t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filtertipospreguntas, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, TiposPreguntas.class,
				query, params, "ID_TIPO_PREGUNTA");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical TiposPreguntas table.
	 *
	 * @param filterTiposPreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<TiposPreguntas>>
	 */
	@Override
	public List<JerarquiaDto<TiposPreguntas>> findAllLikeJerarquia(TiposPreguntas filterTiposPreguntas,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_TIPO_PREGUNTA IDTIPOPREGUNTA,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_PREGUNTAS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_PREGUNTAS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposPreguntas, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_TIPO_PREGUNTA", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					TiposPreguntasDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterTiposPreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(TiposPreguntas filterTiposPreguntas, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_PREGUNTAS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_PREGUNTAS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposPreguntas, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_TIPO_PREGUNTA",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterTiposPreguntas
	 *            TiposPreguntas
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<TiposPreguntas>>
	 */
	@Override
	public List<TableRowDto<TiposPreguntas>> findAllChild(TiposPreguntas filterTiposPreguntas,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM TIPOS_PREGUNTAS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("TIPOS_PREGUNTAS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterTiposPreguntas, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_TIPO_PREGUNTA",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<TiposPreguntas>(this.rwMapPK, "ID_TIPO_PREGUNTA"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the TiposPreguntas entity
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(TiposPreguntas tipospreguntas) {

		StringBuilder where = new StringBuilder(TiposPreguntasDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tipospreguntas != null && tipospreguntas.getIdTipoPregunta() != null) {
			where.append(" AND t1.ID_TIPO_PREGUNTA = ?");
			params.add(tipospreguntas.getIdTipoPregunta());
		}
		if (tipospreguntas != null && tipospreguntas.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(tipospreguntas.getDescripcionCastellano());
		}
		if (tipospreguntas != null && tipospreguntas.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(tipospreguntas.getDescripcionEuskera());
		}
		if (tipospreguntas != null && tipospreguntas.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(tipospreguntas.getFechaRegistro());
		}
		if (tipospreguntas != null && tipospreguntas.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(tipospreguntas.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the TiposPreguntas entity
	 *
	 * @param tipospreguntas
	 *            TiposPreguntas Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(TiposPreguntas tipospreguntas, Boolean startsWith) {

		StringBuilder where = new StringBuilder(TiposPreguntasDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (tipospreguntas != null && tipospreguntas.getIdTipoPregunta() != null) {
			where.append(" AND t1.ID_TIPO_PREGUNTA = ?");
			params.add(tipospreguntas.getIdTipoPregunta());
		}
		if (tipospreguntas != null && tipospreguntas.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tipospreguntas.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + tipospreguntas.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (tipospreguntas != null && tipospreguntas.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tipospreguntas.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + tipospreguntas.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (tipospreguntas != null && tipospreguntas.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(tipospreguntas.getFechaRegistro());
		}
		if (tipospreguntas != null && tipospreguntas.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(tipospreguntas.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + tipospreguntas.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
